/* key-event.c generated by valac 0.40.19, the Vala compiler
 * generated from key-event.vala, do not modify */

/*
 * Copyright (C) 2011-2014 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2014 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>

typedef enum  {
	KKC_MODIFIER_TYPE_NONE = 0,
	KKC_MODIFIER_TYPE_SHIFT_MASK = 1 << 0,
	KKC_MODIFIER_TYPE_LOCK_MASK = 1 << 1,
	KKC_MODIFIER_TYPE_CONTROL_MASK = 1 << 2,
	KKC_MODIFIER_TYPE_MOD1_MASK = 1 << 3,
	KKC_MODIFIER_TYPE_MOD2_MASK = 1 << 4,
	KKC_MODIFIER_TYPE_MOD3_MASK = 1 << 5,
	KKC_MODIFIER_TYPE_MOD4_MASK = 1 << 6,
	KKC_MODIFIER_TYPE_MOD5_MASK = 1 << 7,
	KKC_MODIFIER_TYPE_LSHIFT_MASK = 1 << 22,
	KKC_MODIFIER_TYPE_RSHIFT_MASK = 1 << 23,
	KKC_MODIFIER_TYPE_SUPER_MASK = 1 << 26,
	KKC_MODIFIER_TYPE_HYPER_MASK = 1 << 27,
	KKC_MODIFIER_TYPE_META_MASK = 1 << 28,
	KKC_MODIFIER_TYPE_RELEASE_MASK = 1 << 30
} KkcModifierType;


#define KKC_TYPE_MODIFIER_TYPE (kkc_modifier_type_get_type ())

#define KKC_TYPE_KEY_EVENT (kkc_key_event_get_type ())
#define KKC_KEY_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KKC_TYPE_KEY_EVENT, KkcKeyEvent))
#define KKC_KEY_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KKC_TYPE_KEY_EVENT, KkcKeyEventClass))
#define KKC_IS_KEY_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KKC_TYPE_KEY_EVENT))
#define KKC_IS_KEY_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KKC_TYPE_KEY_EVENT))
#define KKC_KEY_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KKC_TYPE_KEY_EVENT, KkcKeyEventClass))

typedef struct _KkcKeyEvent KkcKeyEvent;
typedef struct _KkcKeyEventClass KkcKeyEventClass;
typedef struct _KkcKeyEventPrivate KkcKeyEventPrivate;
enum  {
	KKC_KEY_EVENT_0_PROPERTY,
	KKC_KEY_EVENT_NAME_PROPERTY,
	KKC_KEY_EVENT_UNICODE_PROPERTY,
	KKC_KEY_EVENT_KEYVAL_PROPERTY,
	KKC_KEY_EVENT_KEYCODE_PROPERTY,
	KKC_KEY_EVENT_MODIFIERS_PROPERTY,
	KKC_KEY_EVENT_NUM_PROPERTIES
};
static GParamSpec* kkc_key_event_properties[KKC_KEY_EVENT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef enum  {
	KKC_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED,
	KKC_KEY_EVENT_FORMAT_ERROR_KEYSYM_NOT_FOUND
} KkcKeyEventFormatError;
#define KKC_KEY_EVENT_FORMAT_ERROR kkc_key_event_format_error_quark ()
struct _KkcKeyEvent {
	GObject parent_instance;
	KkcKeyEventPrivate * priv;
};

struct _KkcKeyEventClass {
	GObjectClass parent_class;
};

struct _KkcKeyEventPrivate {
	gchar* _name;
	gunichar _unicode;
	guint _keyval;
	guint _keycode;
	KkcModifierType _modifiers;
};


static gpointer kkc_key_event_parent_class = NULL;

GQuark kkc_key_event_format_error_quark (void);
GType kkc_modifier_type_get_type (void) G_GNUC_CONST;
GType kkc_key_event_get_type (void) G_GNUC_CONST;
#define KKC_KEY_EVENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), KKC_TYPE_KEY_EVENT, KkcKeyEventPrivate))
KkcKeyEvent* kkc_key_event_new_from_string (const gchar* key,
                                            GError** error);
KkcKeyEvent* kkc_key_event_construct_from_string (GType object_type,
                                                  const gchar* key,
                                                  GError** error);
#define KKC_KEYSYMS_VoidSymbol ((guint) 0xffffff)
guint kkc_key_event_utils_keyval_from_name (const gchar* name);
KkcKeyEvent* kkc_key_event_new_from_x_event (guint keyval,
                                             guint keycode,
                                             KkcModifierType modifiers);
KkcKeyEvent* kkc_key_event_construct_from_x_event (GType object_type,
                                                   guint keyval,
                                                   guint keycode,
                                                   KkcModifierType modifiers);
gchar* kkc_key_event_to_string (KkcKeyEvent* self);
const gchar* kkc_key_event_get_name (KkcKeyEvent* self);
gunichar kkc_key_event_get_unicode (KkcKeyEvent* self);
KkcModifierType kkc_key_event_get_modifiers (KkcKeyEvent* self);
KkcKeyEvent* kkc_key_event_new (guint keyval,
                                guint keycode,
                                KkcModifierType modifiers);
KkcKeyEvent* kkc_key_event_construct (GType object_type,
                                      guint keyval,
                                      guint keycode,
                                      KkcModifierType modifiers);
gchar* kkc_key_event_utils_keyval_name (guint keyval);
void kkc_key_event_set_name (KkcKeyEvent* self,
                             const gchar* value);
gunichar kkc_key_event_utils_keyval_unicode (guint keyval);
void kkc_key_event_set_unicode (KkcKeyEvent* self,
                                gunichar value);
void kkc_key_event_set_keyval (KkcKeyEvent* self,
                               guint value);
void kkc_key_event_set_keycode (KkcKeyEvent* self,
                                guint value);
void kkc_key_event_set_modifiers (KkcKeyEvent* self,
                                  KkcModifierType value);
guint kkc_key_event_get_keyval (KkcKeyEvent* self);
guint kkc_key_event_get_keycode (KkcKeyEvent* self);
static void kkc_key_event_finalize (GObject * obj);
static void _vala_kkc_key_event_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_kkc_key_event_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GQuark
kkc_key_event_format_error_quark (void)
{
	return g_quark_from_static_string ("kkc_key_event_format_error-quark");
}


/**
     * A set of bit-flags to indicate the state of modifier keys.
     */
GType
kkc_modifier_type_get_type (void)
{
	static volatile gsize kkc_modifier_type_type_id__volatile = 0;
	if (g_once_init_enter (&kkc_modifier_type_type_id__volatile)) {
		static const GFlagsValue values[] = {{KKC_MODIFIER_TYPE_NONE, "KKC_MODIFIER_TYPE_NONE", "none"}, {KKC_MODIFIER_TYPE_SHIFT_MASK, "KKC_MODIFIER_TYPE_SHIFT_MASK", "shift-mask"}, {KKC_MODIFIER_TYPE_LOCK_MASK, "KKC_MODIFIER_TYPE_LOCK_MASK", "lock-mask"}, {KKC_MODIFIER_TYPE_CONTROL_MASK, "KKC_MODIFIER_TYPE_CONTROL_MASK", "control-mask"}, {KKC_MODIFIER_TYPE_MOD1_MASK, "KKC_MODIFIER_TYPE_MOD1_MASK", "mod1-mask"}, {KKC_MODIFIER_TYPE_MOD2_MASK, "KKC_MODIFIER_TYPE_MOD2_MASK", "mod2-mask"}, {KKC_MODIFIER_TYPE_MOD3_MASK, "KKC_MODIFIER_TYPE_MOD3_MASK", "mod3-mask"}, {KKC_MODIFIER_TYPE_MOD4_MASK, "KKC_MODIFIER_TYPE_MOD4_MASK", "mod4-mask"}, {KKC_MODIFIER_TYPE_MOD5_MASK, "KKC_MODIFIER_TYPE_MOD5_MASK", "mod5-mask"}, {KKC_MODIFIER_TYPE_LSHIFT_MASK, "KKC_MODIFIER_TYPE_LSHIFT_MASK", "lshift-mask"}, {KKC_MODIFIER_TYPE_RSHIFT_MASK, "KKC_MODIFIER_TYPE_RSHIFT_MASK", "rshift-mask"}, {KKC_MODIFIER_TYPE_SUPER_MASK, "KKC_MODIFIER_TYPE_SUPER_MASK", "super-mask"}, {KKC_MODIFIER_TYPE_HYPER_MASK, "KKC_MODIFIER_TYPE_HYPER_MASK", "hyper-mask"}, {KKC_MODIFIER_TYPE_META_MASK, "KKC_MODIFIER_TYPE_META_MASK", "meta-mask"}, {KKC_MODIFIER_TYPE_RELEASE_MASK, "KKC_MODIFIER_TYPE_RELEASE_MASK", "release-mask"}, {0, NULL, NULL}};
		GType kkc_modifier_type_type_id;
		kkc_modifier_type_type_id = g_flags_register_static ("KkcModifierType", values);
		g_once_init_leave (&kkc_modifier_type_type_id__volatile, kkc_modifier_type_type_id);
	}
	return kkc_modifier_type_type_id__volatile;
}


/**
         * Create a key event from string.
         *
         * @param key a string representation of a key event
         *
         * @return a new KeyEvent
         */
static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		glong _tmp2_;
		_tmp2_ = string_length;
		start = _tmp2_ + start;
	}
	if (end < ((glong) 0)) {
		glong _tmp3_;
		_tmp3_ = string_length;
		end = _tmp3_ + end;
	}
	if (start >= ((glong) 0)) {
		glong _tmp5_;
		_tmp5_ = string_length;
		_tmp4_ = start <= _tmp5_;
	} else {
		_tmp4_ = FALSE;
	}
	g_return_val_if_fail (_tmp4_, NULL);
	if (end >= ((glong) 0)) {
		glong _tmp7_;
		_tmp7_ = string_length;
		_tmp6_ = end <= _tmp7_;
	} else {
		_tmp6_ = FALSE;
	}
	g_return_val_if_fail (_tmp6_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp8_;
	return result;
}


static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		glong _tmp3_;
		_tmp3_ = string_length;
		offset = _tmp3_ + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		glong _tmp4_;
		_tmp4_ = string_length;
		g_return_val_if_fail (offset <= _tmp4_, NULL);
	}
	if (len < ((glong) 0)) {
		glong _tmp5_;
		_tmp5_ = string_length;
		len = _tmp5_ - offset;
	}
	_tmp6_ = string_length;
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp7_;
	return result;
}


KkcKeyEvent*
kkc_key_event_construct_from_string (GType object_type,
                                     const gchar* key,
                                     GError** error)
{
	KkcKeyEvent * self = NULL;
	KkcModifierType _modifiers = 0U;
	guint _keyval = 0U;
	gboolean _tmp0_ = FALSE;
	guint _tmp84_;
	KkcModifierType _tmp85_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (key != NULL, NULL);
	_modifiers = 0;
	_keyval = KKC_KEYSYMS_VoidSymbol;
	if (g_str_has_prefix (key, "(")) {
		_tmp0_ = g_str_has_suffix (key, ")");
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar** strv = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		gint strv_length1;
		gint _strv_size_;
		gint index = 0;
		gchar** _tmp50_;
		gint _tmp50__length1;
		gint _tmp51_;
		const gchar* _tmp52_;
		guint _tmp53_;
		_tmp1_ = string_slice (key, (glong) 1, (glong) -1);
		_tmp2_ = _tmp1_;
		_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, " ", 0);
		_tmp5_ = _tmp4_;
		_tmp5__length1 = _vala_array_length (_tmp3_);
		_g_free0 (_tmp2_);
		strv = _tmp5_;
		strv_length1 = _tmp5__length1;
		_strv_size_ = strv_length1;
		index = 0;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gint _tmp8_;
				gchar** _tmp9_;
				gint _tmp9__length1;
				gchar** _tmp10_;
				gint _tmp10__length1;
				gint _tmp11_;
				const gchar* _tmp12_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = index;
					index = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = index;
				_tmp9_ = strv;
				_tmp9__length1 = strv_length1;
				if (!(_tmp8_ < (_tmp9__length1 - 1))) {
					break;
				}
				_tmp10_ = strv;
				_tmp10__length1 = strv_length1;
				_tmp11_ = index;
				_tmp12_ = _tmp10_[_tmp11_];
				if (g_strcmp0 (_tmp12_, "shift") == 0) {
					KkcModifierType _tmp13_;
					_tmp13_ = _modifiers;
					_modifiers = _tmp13_ | KKC_MODIFIER_TYPE_SHIFT_MASK;
				} else {
					gchar** _tmp14_;
					gint _tmp14__length1;
					gint _tmp15_;
					const gchar* _tmp16_;
					_tmp14_ = strv;
					_tmp14__length1 = strv_length1;
					_tmp15_ = index;
					_tmp16_ = _tmp14_[_tmp15_];
					if (g_strcmp0 (_tmp16_, "control") == 0) {
						KkcModifierType _tmp17_;
						_tmp17_ = _modifiers;
						_modifiers = _tmp17_ | KKC_MODIFIER_TYPE_CONTROL_MASK;
					} else {
						gchar** _tmp18_;
						gint _tmp18__length1;
						gint _tmp19_;
						const gchar* _tmp20_;
						_tmp18_ = strv;
						_tmp18__length1 = strv_length1;
						_tmp19_ = index;
						_tmp20_ = _tmp18_[_tmp19_];
						if (g_strcmp0 (_tmp20_, "meta") == 0) {
							KkcModifierType _tmp21_;
							_tmp21_ = _modifiers;
							_modifiers = _tmp21_ | KKC_MODIFIER_TYPE_META_MASK;
						} else {
							gchar** _tmp22_;
							gint _tmp22__length1;
							gint _tmp23_;
							const gchar* _tmp24_;
							_tmp22_ = strv;
							_tmp22__length1 = strv_length1;
							_tmp23_ = index;
							_tmp24_ = _tmp22_[_tmp23_];
							if (g_strcmp0 (_tmp24_, "hyper") == 0) {
								KkcModifierType _tmp25_;
								_tmp25_ = _modifiers;
								_modifiers = _tmp25_ | KKC_MODIFIER_TYPE_HYPER_MASK;
							} else {
								gchar** _tmp26_;
								gint _tmp26__length1;
								gint _tmp27_;
								const gchar* _tmp28_;
								_tmp26_ = strv;
								_tmp26__length1 = strv_length1;
								_tmp27_ = index;
								_tmp28_ = _tmp26_[_tmp27_];
								if (g_strcmp0 (_tmp28_, "super") == 0) {
									KkcModifierType _tmp29_;
									_tmp29_ = _modifiers;
									_modifiers = _tmp29_ | KKC_MODIFIER_TYPE_SUPER_MASK;
								} else {
									gchar** _tmp30_;
									gint _tmp30__length1;
									gint _tmp31_;
									const gchar* _tmp32_;
									_tmp30_ = strv;
									_tmp30__length1 = strv_length1;
									_tmp31_ = index;
									_tmp32_ = _tmp30_[_tmp31_];
									if (g_strcmp0 (_tmp32_, "alt") == 0) {
										KkcModifierType _tmp33_;
										_tmp33_ = _modifiers;
										_modifiers = _tmp33_ | KKC_MODIFIER_TYPE_MOD1_MASK;
									} else {
										gchar** _tmp34_;
										gint _tmp34__length1;
										gint _tmp35_;
										const gchar* _tmp36_;
										_tmp34_ = strv;
										_tmp34__length1 = strv_length1;
										_tmp35_ = index;
										_tmp36_ = _tmp34_[_tmp35_];
										if (g_strcmp0 (_tmp36_, "lshift") == 0) {
											KkcModifierType _tmp37_;
											_tmp37_ = _modifiers;
											_modifiers = _tmp37_ | KKC_MODIFIER_TYPE_LSHIFT_MASK;
										} else {
											gchar** _tmp38_;
											gint _tmp38__length1;
											gint _tmp39_;
											const gchar* _tmp40_;
											_tmp38_ = strv;
											_tmp38__length1 = strv_length1;
											_tmp39_ = index;
											_tmp40_ = _tmp38_[_tmp39_];
											if (g_strcmp0 (_tmp40_, "rshift") == 0) {
												KkcModifierType _tmp41_;
												_tmp41_ = _modifiers;
												_modifiers = _tmp41_ | KKC_MODIFIER_TYPE_RSHIFT_MASK;
											} else {
												gchar** _tmp42_;
												gint _tmp42__length1;
												gint _tmp43_;
												const gchar* _tmp44_;
												_tmp42_ = strv;
												_tmp42__length1 = strv_length1;
												_tmp43_ = index;
												_tmp44_ = _tmp42_[_tmp43_];
												if (g_strcmp0 (_tmp44_, "release") == 0) {
													KkcModifierType _tmp45_;
													_tmp45_ = _modifiers;
													_modifiers = _tmp45_ | KKC_MODIFIER_TYPE_RELEASE_MASK;
												} else {
													gchar** _tmp46_;
													gint _tmp46__length1;
													gint _tmp47_;
													const gchar* _tmp48_;
													GError* _tmp49_;
													_tmp46_ = strv;
													_tmp46__length1 = strv_length1;
													_tmp47_ = index;
													_tmp48_ = _tmp46_[_tmp47_];
													_tmp49_ = g_error_new (KKC_KEY_EVENT_FORMAT_ERROR, KKC_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED, "unknown modifier %s", _tmp48_);
													_inner_error0_ = _tmp49_;
													if (_inner_error0_->domain == KKC_KEY_EVENT_FORMAT_ERROR) {
														g_propagate_error (error, _inner_error0_);
														strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
														_g_object_unref0 (self);
														return NULL;
													} else {
														strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
														g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
														g_clear_error (&_inner_error0_);
														return NULL;
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
		_tmp50_ = strv;
		_tmp50__length1 = strv_length1;
		_tmp51_ = index;
		_tmp52_ = _tmp50_[_tmp51_];
		_keyval = kkc_key_event_utils_keyval_from_name (_tmp52_);
		_tmp53_ = _keyval;
		if (_tmp53_ == KKC_KEYSYMS_VoidSymbol) {
			gchar** _tmp54_;
			gint _tmp54__length1;
			gint _tmp55_;
			const gchar* _tmp56_;
			GError* _tmp57_;
			_tmp54_ = strv;
			_tmp54__length1 = strv_length1;
			_tmp55_ = index;
			_tmp56_ = _tmp54_[_tmp55_];
			_tmp57_ = g_error_new (KKC_KEY_EVENT_FORMAT_ERROR, KKC_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED, "unknown keyval %s", _tmp56_);
			_inner_error0_ = _tmp57_;
			if (_inner_error0_->domain == KKC_KEY_EVENT_FORMAT_ERROR) {
				g_propagate_error (error, _inner_error0_);
				strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
				_g_object_unref0 (self);
				return NULL;
			} else {
				strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
	} else {
		gint index = 0;
		gchar* _name = NULL;
		gint _tmp58_;
		const gchar* _tmp80_;
		guint _tmp81_;
		index = string_last_index_of (key, "-", 0);
		_name = NULL;
		_tmp58_ = index;
		if (_tmp58_ > 0) {
			gchar** mods = NULL;
			gint _tmp59_;
			gchar* _tmp60_;
			gchar* _tmp61_;
			gchar** _tmp62_;
			gchar** _tmp63_;
			gchar** _tmp64_;
			gint _tmp64__length1;
			gint mods_length1;
			gint _mods_size_;
			gchar** _tmp65_;
			gint _tmp65__length1;
			gint _tmp77_;
			gchar* _tmp78_;
			_tmp59_ = index;
			_tmp60_ = string_substring (key, (glong) 0, (glong) _tmp59_);
			_tmp61_ = _tmp60_;
			_tmp63_ = _tmp62_ = g_strsplit (_tmp61_, "-", 0);
			_tmp64_ = _tmp63_;
			_tmp64__length1 = _vala_array_length (_tmp62_);
			_g_free0 (_tmp61_);
			mods = _tmp64_;
			mods_length1 = _tmp64__length1;
			_mods_size_ = mods_length1;
			_tmp65_ = mods;
			_tmp65__length1 = mods_length1;
			{
				gchar** mod_collection = NULL;
				gint mod_collection_length1 = 0;
				gint _mod_collection_size_ = 0;
				gint mod_it = 0;
				mod_collection = _tmp65_;
				mod_collection_length1 = _tmp65__length1;
				for (mod_it = 0; mod_it < mod_collection_length1; mod_it = mod_it + 1) {
					gchar* _tmp66_;
					gchar* mod = NULL;
					_tmp66_ = g_strdup (mod_collection[mod_it]);
					mod = _tmp66_;
					{
						const gchar* _tmp67_;
						_tmp67_ = mod;
						if (g_strcmp0 (_tmp67_, "S") == 0) {
							KkcModifierType _tmp68_;
							_tmp68_ = _modifiers;
							_modifiers = _tmp68_ | KKC_MODIFIER_TYPE_SHIFT_MASK;
						} else {
							const gchar* _tmp69_;
							_tmp69_ = mod;
							if (g_strcmp0 (_tmp69_, "C") == 0) {
								KkcModifierType _tmp70_;
								_tmp70_ = _modifiers;
								_modifiers = _tmp70_ | KKC_MODIFIER_TYPE_CONTROL_MASK;
							} else {
								const gchar* _tmp71_;
								_tmp71_ = mod;
								if (g_strcmp0 (_tmp71_, "A") == 0) {
									KkcModifierType _tmp72_;
									_tmp72_ = _modifiers;
									_modifiers = _tmp72_ | KKC_MODIFIER_TYPE_MOD1_MASK;
								} else {
									const gchar* _tmp73_;
									_tmp73_ = mod;
									if (g_strcmp0 (_tmp73_, "M") == 0) {
										KkcModifierType _tmp74_;
										_tmp74_ = _modifiers;
										_modifiers = _tmp74_ | KKC_MODIFIER_TYPE_META_MASK;
									} else {
										const gchar* _tmp75_;
										_tmp75_ = mod;
										if (g_strcmp0 (_tmp75_, "G") == 0) {
											KkcModifierType _tmp76_;
											_tmp76_ = _modifiers;
											_modifiers = _tmp76_ | KKC_MODIFIER_TYPE_MOD5_MASK;
										}
									}
								}
							}
						}
						_g_free0 (mod);
					}
				}
			}
			_tmp77_ = index;
			_tmp78_ = string_substring (key, (glong) (_tmp77_ + 1), (glong) -1);
			_g_free0 (_name);
			_name = _tmp78_;
			mods = (_vala_array_free (mods, mods_length1, (GDestroyNotify) g_free), NULL);
		} else {
			gchar* _tmp79_;
			_modifiers = KKC_MODIFIER_TYPE_NONE;
			_tmp79_ = g_strdup (key);
			_g_free0 (_name);
			_name = _tmp79_;
		}
		_tmp80_ = _name;
		_keyval = kkc_key_event_utils_keyval_from_name (_tmp80_);
		_tmp81_ = _keyval;
		if (_tmp81_ == KKC_KEYSYMS_VoidSymbol) {
			const gchar* _tmp82_;
			GError* _tmp83_;
			_tmp82_ = _name;
			_tmp83_ = g_error_new (KKC_KEY_EVENT_FORMAT_ERROR, KKC_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED, "unknown keyval %s", _tmp82_);
			_inner_error0_ = _tmp83_;
			if (_inner_error0_->domain == KKC_KEY_EVENT_FORMAT_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (_name);
				_g_object_unref0 (self);
				return NULL;
			} else {
				_g_free0 (_name);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_g_free0 (_name);
	}
	_tmp84_ = _keyval;
	_tmp85_ = _modifiers;
	self = (KkcKeyEvent*) kkc_key_event_construct_from_x_event (object_type, _tmp84_, (guint) 0, _tmp85_);
	return self;
}


KkcKeyEvent*
kkc_key_event_new_from_string (const gchar* key,
                               GError** error)
{
	return kkc_key_event_construct_from_string (KKC_TYPE_KEY_EVENT, key, error);
}


/**
         * Convert the KeyEvent to string.
         *
         * @return a string representing the KeyEvent
         */
static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* result = NULL;
	gchar* str = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	_tmp0_ = g_new0 (gchar, 7);
	str = (gchar*) _tmp0_;
	_tmp1_ = str;
	g_unichar_to_utf8 (self, _tmp1_);
	result = str;
	return result;
}


static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  int str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp20_;
		gint _tmp22_;
		gsize _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		const gchar* res = NULL;
		gsize _tmp27_;
		void* _tmp28_;
		void* ptr = NULL;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
		void* _tmp31_;
		const gchar* _tmp44_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp12_ = 0;
				gint _tmp13_;
				const gchar* _tmp14_;
				gsize _tmp19_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					gint _tmp8_;
					_tmp8_ = i;
					_tmp7_ = _tmp8_ < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp9_ = FALSE;
					if (str_array_length1 == -1) {
						gint _tmp10_;
						const gchar* _tmp11_;
						_tmp10_ = i;
						_tmp11_ = str_array[_tmp10_];
						_tmp9_ = _tmp11_ != NULL;
					} else {
						_tmp9_ = FALSE;
					}
					_tmp6_ = _tmp9_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp13_ = i;
				_tmp14_ = str_array[_tmp13_];
				if (_tmp14_ != NULL) {
					gint _tmp15_;
					const gchar* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					_tmp15_ = i;
					_tmp16_ = str_array[_tmp15_];
					_tmp17_ = strlen ((const gchar*) _tmp16_);
					_tmp18_ = _tmp17_;
					_tmp12_ = _tmp18_;
				} else {
					_tmp12_ = 0;
				}
				_tmp19_ = len;
				len = _tmp19_ + _tmp12_;
			}
		}
		_tmp20_ = i;
		if (_tmp20_ == 0) {
			gchar* _tmp21_;
			_tmp21_ = g_strdup ("");
			result = _tmp21_;
			return result;
		}
		_tmp22_ = i;
		str_array_length1 = _tmp22_;
		_tmp23_ = len;
		_tmp24_ = strlen ((const gchar*) separator);
		_tmp25_ = _tmp24_;
		_tmp26_ = i;
		len = _tmp23_ + (_tmp25_ * (_tmp26_ - 1));
		_tmp27_ = len;
		_tmp28_ = g_malloc (_tmp27_);
		res = _tmp28_;
		_tmp29_ = res;
		_tmp30_ = str_array[0];
		_tmp31_ = g_stpcpy ((void*) _tmp29_, (const gchar*) _tmp30_);
		ptr = _tmp31_;
		{
			gboolean _tmp32_ = FALSE;
			i = 1;
			_tmp32_ = TRUE;
			while (TRUE) {
				gint _tmp34_;
				void* _tmp35_;
				void* _tmp36_;
				const gchar* _tmp37_ = NULL;
				gint _tmp38_;
				const gchar* _tmp39_;
				void* _tmp42_;
				void* _tmp43_;
				if (!_tmp32_) {
					gint _tmp33_;
					_tmp33_ = i;
					i = _tmp33_ + 1;
				}
				_tmp32_ = FALSE;
				_tmp34_ = i;
				if (!(_tmp34_ < str_array_length1)) {
					break;
				}
				_tmp35_ = ptr;
				_tmp36_ = g_stpcpy (_tmp35_, (const gchar*) separator);
				ptr = _tmp36_;
				_tmp38_ = i;
				_tmp39_ = str_array[_tmp38_];
				if (_tmp39_ != NULL) {
					gint _tmp40_;
					const gchar* _tmp41_;
					_tmp40_ = i;
					_tmp41_ = str_array[_tmp40_];
					_tmp37_ = (const gchar*) _tmp41_;
				} else {
					_tmp37_ = "";
				}
				_tmp42_ = ptr;
				_tmp43_ = g_stpcpy (_tmp42_, _tmp37_);
				ptr = _tmp43_;
			}
		}
		_tmp44_ = res;
		res = NULL;
		result = (gchar*) _tmp44_;
		return result;
	} else {
		gchar* _tmp45_;
		_tmp45_ = g_strdup ("");
		result = _tmp45_;
		return result;
	}
}


gchar*
kkc_key_event_to_string (KkcKeyEvent* self)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* _base = NULL;
	gchar* _tmp6_;
	KkcModifierType _tmp7_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->_name;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = self->priv->_name;
		_tmp3_ = g_strdup (_tmp2_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
	} else {
		gunichar _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = self->priv->_unicode;
		_tmp5_ = g_unichar_to_string (_tmp4_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp5_;
	}
	_tmp6_ = g_strdup (_tmp0_);
	_base = _tmp6_;
	_tmp7_ = self->priv->_modifiers;
	if (_tmp7_ != 0) {
		GeeArrayList* elements = NULL;
		GeeArrayList* _tmp8_;
		KkcModifierType _tmp9_;
		KkcModifierType _tmp11_;
		KkcModifierType _tmp13_;
		KkcModifierType _tmp15_;
		KkcModifierType _tmp17_;
		KkcModifierType _tmp19_;
		KkcModifierType _tmp21_;
		KkcModifierType _tmp23_;
		KkcModifierType _tmp25_;
		GeeArrayList* _tmp27_;
		const gchar* _tmp28_;
		GeeArrayList* _tmp29_;
		gchar** array = NULL;
		GeeArrayList* _tmp30_;
		gint _tmp31_ = 0;
		gpointer* _tmp32_;
		gint array_length1;
		gint _array_size_;
		gchar** _tmp33_;
		gint _tmp33__length1;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		_tmp8_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
		elements = _tmp8_;
		_tmp9_ = self->priv->_modifiers;
		if ((_tmp9_ & KKC_MODIFIER_TYPE_SHIFT_MASK) != 0) {
			GeeArrayList* _tmp10_;
			_tmp10_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, "shift");
		}
		_tmp11_ = self->priv->_modifiers;
		if ((_tmp11_ & KKC_MODIFIER_TYPE_CONTROL_MASK) != 0) {
			GeeArrayList* _tmp12_;
			_tmp12_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, "control");
		}
		_tmp13_ = self->priv->_modifiers;
		if ((_tmp13_ & KKC_MODIFIER_TYPE_META_MASK) != 0) {
			GeeArrayList* _tmp14_;
			_tmp14_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, "meta");
		}
		_tmp15_ = self->priv->_modifiers;
		if ((_tmp15_ & KKC_MODIFIER_TYPE_HYPER_MASK) != 0) {
			GeeArrayList* _tmp16_;
			_tmp16_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, "hyper");
		}
		_tmp17_ = self->priv->_modifiers;
		if ((_tmp17_ & KKC_MODIFIER_TYPE_SUPER_MASK) != 0) {
			GeeArrayList* _tmp18_;
			_tmp18_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, "super");
		}
		_tmp19_ = self->priv->_modifiers;
		if ((_tmp19_ & KKC_MODIFIER_TYPE_MOD1_MASK) != 0) {
			GeeArrayList* _tmp20_;
			_tmp20_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, "alt");
		}
		_tmp21_ = self->priv->_modifiers;
		if ((_tmp21_ & KKC_MODIFIER_TYPE_LSHIFT_MASK) != 0) {
			GeeArrayList* _tmp22_;
			_tmp22_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, "lshift");
		}
		_tmp23_ = self->priv->_modifiers;
		if ((_tmp23_ & KKC_MODIFIER_TYPE_RSHIFT_MASK) != 0) {
			GeeArrayList* _tmp24_;
			_tmp24_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, "rshift");
		}
		_tmp25_ = self->priv->_modifiers;
		if ((_tmp25_ & KKC_MODIFIER_TYPE_RELEASE_MASK) != 0) {
			GeeArrayList* _tmp26_;
			_tmp26_ = elements;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, "release");
		}
		_tmp27_ = elements;
		_tmp28_ = _base;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp28_);
		_tmp29_ = elements;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, NULL);
		_tmp30_ = elements;
		_tmp32_ = gee_collection_to_array ((GeeCollection*) _tmp30_, &_tmp31_);
		array = _tmp32_;
		array_length1 = _tmp31_;
		_array_size_ = array_length1;
		array_length1 = -1;
		_tmp33_ = array;
		_tmp33__length1 = array_length1;
		_tmp34_ = _vala_g_strjoinv (" ", _tmp33_, _tmp33__length1);
		_tmp35_ = _tmp34_;
		_tmp36_ = g_strconcat ("(", _tmp35_, NULL);
		_tmp37_ = _tmp36_;
		_tmp38_ = g_strconcat (_tmp37_, ")", NULL);
		_tmp39_ = _tmp38_;
		_g_free0 (_tmp37_);
		_g_free0 (_tmp35_);
		result = _tmp39_;
		array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_free), NULL);
		_g_object_unref0 (elements);
		_g_free0 (_base);
		_g_free0 (_tmp0_);
		return result;
	} else {
		result = _base;
		_g_free0 (_tmp0_);
		return result;
	}
	_g_free0 (_base);
	_g_free0 (_tmp0_);
}


KkcKeyEvent*
kkc_key_event_construct_from_x_event (GType object_type,
                                      guint keyval,
                                      guint keycode,
                                      KkcModifierType modifiers)
{
	KkcKeyEvent * self = NULL;
	self = (KkcKeyEvent*) kkc_key_event_construct (object_type, keyval, keycode, modifiers);
	return self;
}


KkcKeyEvent*
kkc_key_event_new_from_x_event (guint keyval,
                                guint keycode,
                                KkcModifierType modifiers)
{
	return kkc_key_event_construct_from_x_event (KKC_TYPE_KEY_EVENT, keyval, keycode, modifiers);
}


/**
         * Create a key event from an X event.
         *
         * @param keyval an X keysym
         * @param keycode an X keycode
         * @param modifiers modifier mask
         *
         * @return a new KeyEvent
         */
KkcKeyEvent*
kkc_key_event_construct (GType object_type,
                         guint keyval,
                         guint keycode,
                         KkcModifierType modifiers)
{
	KkcKeyEvent * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (KkcKeyEvent*) g_object_new (object_type, NULL);
	_tmp0_ = kkc_key_event_utils_keyval_name (keyval);
	_tmp1_ = _tmp0_;
	kkc_key_event_set_name (self, _tmp1_);
	_g_free0 (_tmp1_);
	kkc_key_event_set_unicode (self, kkc_key_event_utils_keyval_unicode (keyval));
	if (((guint) 0x21) <= keyval) {
		_tmp2_ = keyval < ((guint) 0x7F);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		modifiers = modifiers & (~(KKC_MODIFIER_TYPE_SHIFT_MASK | KKC_MODIFIER_TYPE_MOD5_MASK));
	}
	kkc_key_event_set_keyval (self, keyval);
	kkc_key_event_set_keycode (self, keycode);
	kkc_key_event_set_modifiers (self, modifiers);
	return self;
}


KkcKeyEvent*
kkc_key_event_new (guint keyval,
                   guint keycode,
                   KkcModifierType modifiers)
{
	return kkc_key_event_construct (KKC_TYPE_KEY_EVENT, keyval, keycode, modifiers);
}


const gchar*
kkc_key_event_get_name (KkcKeyEvent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


void
kkc_key_event_set_name (KkcKeyEvent* self,
                        const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, kkc_key_event_get_name (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, kkc_key_event_properties[KKC_KEY_EVENT_NAME_PROPERTY]);
	}
}


gunichar
kkc_key_event_get_unicode (KkcKeyEvent* self)
{
	gunichar result;
	gunichar _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_unicode;
	result = _tmp0_;
	return result;
}


void
kkc_key_event_set_unicode (KkcKeyEvent* self,
                           gunichar value)
{
	g_return_if_fail (self != NULL);
	if (kkc_key_event_get_unicode (self) != value) {
		self->priv->_unicode = value;
		g_object_notify_by_pspec ((GObject *) self, kkc_key_event_properties[KKC_KEY_EVENT_UNICODE_PROPERTY]);
	}
}


guint
kkc_key_event_get_keyval (KkcKeyEvent* self)
{
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_keyval;
	result = _tmp0_;
	return result;
}


void
kkc_key_event_set_keyval (KkcKeyEvent* self,
                          guint value)
{
	g_return_if_fail (self != NULL);
	if (kkc_key_event_get_keyval (self) != value) {
		self->priv->_keyval = value;
		g_object_notify_by_pspec ((GObject *) self, kkc_key_event_properties[KKC_KEY_EVENT_KEYVAL_PROPERTY]);
	}
}


guint
kkc_key_event_get_keycode (KkcKeyEvent* self)
{
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_keycode;
	result = _tmp0_;
	return result;
}


void
kkc_key_event_set_keycode (KkcKeyEvent* self,
                           guint value)
{
	g_return_if_fail (self != NULL);
	if (kkc_key_event_get_keycode (self) != value) {
		self->priv->_keycode = value;
		g_object_notify_by_pspec ((GObject *) self, kkc_key_event_properties[KKC_KEY_EVENT_KEYCODE_PROPERTY]);
	}
}


KkcModifierType
kkc_key_event_get_modifiers (KkcKeyEvent* self)
{
	KkcModifierType result;
	KkcModifierType _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_modifiers;
	result = _tmp0_;
	return result;
}


void
kkc_key_event_set_modifiers (KkcKeyEvent* self,
                             KkcModifierType value)
{
	g_return_if_fail (self != NULL);
	if (kkc_key_event_get_modifiers (self) != value) {
		self->priv->_modifiers = value;
		g_object_notify_by_pspec ((GObject *) self, kkc_key_event_properties[KKC_KEY_EVENT_MODIFIERS_PROPERTY]);
	}
}


static void
kkc_key_event_class_init (KkcKeyEventClass * klass)
{
	kkc_key_event_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (KkcKeyEventPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_kkc_key_event_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_kkc_key_event_set_property;
	G_OBJECT_CLASS (klass)->finalize = kkc_key_event_finalize;
	/**
	         * The base name of the KeyEvent.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_NAME_PROPERTY, kkc_key_event_properties[KKC_KEY_EVENT_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	/**
	         * The base unicode output of the KeyEvent.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_UNICODE_PROPERTY, kkc_key_event_properties[KKC_KEY_EVENT_UNICODE_PROPERTY] = g_param_spec_uint ("unicode", "unicode", "unicode", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	/**
	         * X keyval.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_KEYVAL_PROPERTY, kkc_key_event_properties[KKC_KEY_EVENT_KEYVAL_PROPERTY] = g_param_spec_uint ("keyval", "keyval", "keyval", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	/**
	         * X keycode.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_KEYCODE_PROPERTY, kkc_key_event_properties[KKC_KEY_EVENT_KEYCODE_PROPERTY] = g_param_spec_uint ("keycode", "keycode", "keycode", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	/**
	         * Modifier mask.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_MODIFIERS_PROPERTY, kkc_key_event_properties[KKC_KEY_EVENT_MODIFIERS_PROPERTY] = g_param_spec_flags ("modifiers", "modifiers", "modifiers", KKC_TYPE_MODIFIER_TYPE, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}


static void
kkc_key_event_instance_init (KkcKeyEvent * self)
{
	self->priv = KKC_KEY_EVENT_GET_PRIVATE (self);
}


static void
kkc_key_event_finalize (GObject * obj)
{
	KkcKeyEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KKC_TYPE_KEY_EVENT, KkcKeyEvent);
	_g_free0 (self->priv->_name);
	G_OBJECT_CLASS (kkc_key_event_parent_class)->finalize (obj);
}


/**
     * Object representing a key event.
     */
GType
kkc_key_event_get_type (void)
{
	static volatile gsize kkc_key_event_type_id__volatile = 0;
	if (g_once_init_enter (&kkc_key_event_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (KkcKeyEventClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_key_event_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcKeyEvent), 0, (GInstanceInitFunc) kkc_key_event_instance_init, NULL };
		GType kkc_key_event_type_id;
		kkc_key_event_type_id = g_type_register_static (G_TYPE_OBJECT, "KkcKeyEvent", &g_define_type_info, 0);
		g_once_init_leave (&kkc_key_event_type_id__volatile, kkc_key_event_type_id);
	}
	return kkc_key_event_type_id__volatile;
}


static void
_vala_kkc_key_event_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	KkcKeyEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KKC_TYPE_KEY_EVENT, KkcKeyEvent);
	switch (property_id) {
		case KKC_KEY_EVENT_NAME_PROPERTY:
		g_value_set_string (value, kkc_key_event_get_name (self));
		break;
		case KKC_KEY_EVENT_UNICODE_PROPERTY:
		g_value_set_uint (value, kkc_key_event_get_unicode (self));
		break;
		case KKC_KEY_EVENT_KEYVAL_PROPERTY:
		g_value_set_uint (value, kkc_key_event_get_keyval (self));
		break;
		case KKC_KEY_EVENT_KEYCODE_PROPERTY:
		g_value_set_uint (value, kkc_key_event_get_keycode (self));
		break;
		case KKC_KEY_EVENT_MODIFIERS_PROPERTY:
		g_value_set_flags (value, kkc_key_event_get_modifiers (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_kkc_key_event_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	KkcKeyEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KKC_TYPE_KEY_EVENT, KkcKeyEvent);
	switch (property_id) {
		case KKC_KEY_EVENT_NAME_PROPERTY:
		kkc_key_event_set_name (self, g_value_get_string (value));
		break;
		case KKC_KEY_EVENT_UNICODE_PROPERTY:
		kkc_key_event_set_unicode (self, g_value_get_uint (value));
		break;
		case KKC_KEY_EVENT_KEYVAL_PROPERTY:
		kkc_key_event_set_keyval (self, g_value_get_uint (value));
		break;
		case KKC_KEY_EVENT_KEYCODE_PROPERTY:
		kkc_key_event_set_keycode (self, g_value_get_uint (value));
		break;
		case KKC_KEY_EVENT_MODIFIERS_PROPERTY:
		kkc_key_event_set_modifiers (self, g_value_get_flags (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



